searchNodes=[{"doc":"Provides an API to validate, convert, and save files to abstract storages. Usage Suppose you have a definition MyApp.Image . Then you can save a file from Plug.Upload struct like this. def save ( % Plug.Upload { path : path } ) do path |&gt; IVCU.File . from_path ( ) |&gt; IVCU . save ( MyApp.Image ) end See Getting Started guide for more information.","ref":"IVCU.html","title":"IVCU","type":"module"},{"doc":"Delete files from the storage. Algorithm generate filenames for versions specified in the definition module; delete the files from the storage. Note definition must implement Definition behaviour.","ref":"IVCU.html#delete/2","title":"IVCU.delete/2","type":"function"},{"doc":"Save the file with provided definition. Algorithm validate the original file; generate new filenames; apply transformations to the file providing new filenames; put the new files in the storage. Note definition must implement Definition behaviour. Note Expected order of files is the same as order in which versions were provided in the definition .","ref":"IVCU.html#save/2","title":"IVCU.save/2","type":"function"},{"doc":"Return urls to access all the versions of the file in the storage. Note definition must implement Definition behaviour.","ref":"IVCU.html#urls/2","title":"IVCU.urls/2","type":"function"},{"doc":"An interface for file processing. Example Suppose we have defined storage and converter modules as MyApp.FileStorage and MyApp.ImageConverter respectively. Then we can provide a specific definition for some images. defmodule MyApp.Image do @behaviour IVCU.Definition def versions , do : [ :thumb , :original ] def storage , do : MyApp.FileStorage def converter , do : MyApp.ImageConverter def validate ( %{ filename : filename } ) do if Path . extname ( filename ) in ~w(.png .jpg .jpeg) do :ok else { :error , :invalid_image_extension } end end def filename ( version , filename ) do extname = Path . extname ( filename ) base = filename |&gt; String . replace ( extname , &quot;&quot; ) &quot; \#{ base } _ \#{ version } \#{ extname } &quot; end end Using that definition you get two file formats: :thumb and :original and pass only files with .png , .jpg , or .jpeg extensions. Also you stored filenames will be looking like &lt;original base filename&gt;_&lt;version&gt;.&lt;original extension&gt; .","ref":"IVCU.Definition.html","title":"IVCU.Definition","type":"behaviour"},{"doc":"Return Converter module.","ref":"IVCU.Definition.html#c:converter/0","title":"IVCU.Definition.converter/0","type":"callback"},{"doc":"Get a new filename for the provided version.","ref":"IVCU.Definition.html#c:filename/2","title":"IVCU.Definition.filename/2","type":"callback"},{"doc":"Return Storage module.","ref":"IVCU.Definition.html#c:storage/0","title":"IVCU.Definition.storage/0","type":"callback"},{"doc":"Check if the file is allowed to be processed and put into a storage.","ref":"IVCU.Definition.html#c:validate/1","title":"IVCU.Definition.validate/1","type":"callback"},{"doc":"Return a list of versions. Note If you provide :original among versions, the file with this version won't be modified by the converter.","ref":"IVCU.Definition.html#c:versions/0","title":"IVCU.Definition.versions/0","type":"callback"},{"doc":"A name for the version of the processed image.","ref":"IVCU.Definition.html#t:version/0","title":"IVCU.Definition.version/0","type":"type"},{"doc":"Internal file representation used everywhere else in the library.","ref":"IVCU.File.html","title":"IVCU.File","type":"module"},{"doc":"Create new File struct from file content. This function is supposed to be used when you need to save some binary payload as a file. Example iex(1)&gt; % IVCU.File { path : nil , content : &lt;&lt; 255 , 255 &gt;&gt; } = ...(1)&gt; IVCU.File . from_content ( &lt;&lt; 255 , 255 &gt;&gt; ) Note This function puts random :filename with no extension into the file.","ref":"IVCU.File.html#from_content/1","title":"IVCU.File.from_content/1","type":"function"},{"doc":"Create new File struct with only name present. This function is supposed to be used for deletion of an already existing file or for getting an URL for the file. Example iex(1)&gt; IVCU.File . from_name ( &quot;file.txt&quot; ) % IVCU.File { filename : &quot;file.txt&quot; , path : nil , content : nil } Warning It cannot be used to save a new file, because we need some source from which we copy the file.","ref":"IVCU.File.html#from_name/1","title":"IVCU.File.from_name/1","type":"function"},{"doc":"Create new File struct from path. This function is supposed to be used when you need to save a file already stored on the filesystem. Example iex(1)&gt; IVCU.File . from_path ( &quot;./uploads/file.txt&quot; ) % IVCU.File { filename : &quot;file.txt&quot; , path : &quot;./uploads/file.txt&quot; , content : nil }","ref":"IVCU.File.html#from_path/1","title":"IVCU.File.from_path/1","type":"function"},{"doc":"Return random filename.","ref":"IVCU.File.html#random_filename/0","title":"IVCU.File.random_filename/0","type":"function"},{"doc":"Replaces :filename with random filename with no extension. It's usefull when you need to override original filename to keep filenames unique. Example iex(1)&gt; file = IVCU.File . from_path ( &quot;./uploads/file.txt&quot; ) iex(2)&gt; % IVCU.File { ...(2)&gt; content : nil , ...(2)&gt; path : &quot;./uploads/file.txt&quot; , ...(2)&gt; filename : filename ...(2)&gt; } = IVCU.File . with_random_filename ( file ) iex(3)&gt; filename != file . filename true","ref":"IVCU.File.html#with_random_filename/1","title":"IVCU.File.with_random_filename/1","type":"function"},{"doc":"File representation used in the library. File must always have a :name , even though it may not have :path or :content depending on the way it was produced.","ref":"IVCU.File.html#t:t/0","title":"IVCU.File.t/0","type":"type"},{"doc":"Provides a helper to generate a converter that uses any cmd converter for files ( convert binary from imagemagick in example). Usage To use the converter you need to define a module. defmodule MyApp.ImageConverter do use IVCU.Converter.CMD , args : %{ thumb : [ &quot;convert&quot; , :input , &quot;-thumbnail&quot; , &quot;100x100^&quot; , &quot;-gravity&quot; , &quot;center&quot; , &quot;-extent&quot; , &quot;100x100&quot; , :output ] } end :args is a map where the commands for different versions are provided. :input and :output represent positions of input and output files for the command. Now you can use your storage module in your definition .","ref":"IVCU.Converter.CMD.html","title":"IVCU.Converter.CMD","type":"module"},{"doc":"Provides a helper to generate a storage that saves all the files localy. Usage First you need to define a configurable module for your storage. defmodule MyApp.FileStorage do use IVCU.Storage.Local , otp_app : :my_app end Then you need to proceed to configuration part. config :my_app , MyApp.FileStorage , dir : &quot;./uploads&quot; Now you can use your storage module in your definition .","ref":"IVCU.Storage.Local.html","title":"IVCU.Storage.Local","type":"module"},{"doc":"An interface for a strategy that handles applying multiple actions on a collection. It may be configured via application configuration. config :ivcu , collection_traverser : IVCU.CollectionTraverser.SyncTraverser The configuration above is default. Warning You only need to implement this behaviour if you are not satisfied with already implemented ones. Default is IVCU.CollectionTraverser.SyncTraverser .","ref":"IVCU.CollectionTraverser.html","title":"IVCU.CollectionTraverser","type":"behaviour"},{"doc":"Apply the function to the collection and return result. Example Imagine we have a module Collection that implements this behaviour. Then we could do the following. iex(1)&gt; Collection . traverse ( [ 1 , 2 , 3 ] , fn x -&gt; { :ok , x + 1 } end ) { :ok , [ 2 , 3 , 4 ] } iex(2)&gt; Collection . traverse ( [ 1 , 2 , 3 ] , fn x -&gt; ...(2)&gt; if rem ( x , 2 ) == 0 do ...(2)&gt; { :error , &quot; \#{ x } is even&quot; } ...(2)&gt; else ...(2)&gt; { :ok , x + 1 } ...(2)&gt; end ...(2)&gt; end ) { :error , &quot;2 is even&quot; }","ref":"IVCU.CollectionTraverser.html#c:traverse/2","title":"IVCU.CollectionTraverser.traverse/2","type":"callback"},{"doc":"","ref":"IVCU.CollectionTraverser.html#t:result/2","title":"IVCU.CollectionTraverser.result/2","type":"type"},{"doc":"This module implements IVCU.CollectionTraverser in asynchronous way making operations potentially faster.","ref":"IVCU.CollectionTraverser.AsyncTraverser.html","title":"IVCU.CollectionTraverser.AsyncTraverser","type":"module"},{"doc":"Synchronously IVCU.CollectionTraverser implementation without exception handling. Info It returns after the first failed operation.","ref":"IVCU.CollectionTraverser.SyncTraverser.html","title":"IVCU.CollectionTraverser.SyncTraverser","type":"module"},{"doc":"Interface module for file convertation. Warning Usually you don't need to implement converter yourself as there already exists IVCU.Converter.CMD helper. That's the reason this module is marked as &quot;internal&quot;.","ref":"IVCU.Converter.html","title":"IVCU.Converter","type":"behaviour"},{"doc":"Remove a file produced by the converter. This action is triggered after storage performed IVCU.Storage.put/1 call.","ref":"IVCU.Converter.html#c:clean!/1","title":"IVCU.Converter.clean!/1","type":"callback"},{"doc":"Trigger the convert action. Note When version is :original the command should be treated as a special case where the file stays unchanged.","ref":"IVCU.Converter.html#c:convert/3","title":"IVCU.Converter.convert/3","type":"callback"},{"doc":"Interface module for file storage. Warning Usually you don't need to implement storage yourself as there already exists IVCU.Storage.Local helper. That's the reason this module is marked as &quot;internal&quot;.","ref":"IVCU.Storage.html","title":"IVCU.Storage","type":"behaviour"},{"doc":"Delete the file from the storage.","ref":"IVCU.Storage.html#c:delete/1","title":"IVCU.Storage.delete/1","type":"callback"},{"doc":"Put the file to the storages.","ref":"IVCU.Storage.html#c:put/1","title":"IVCU.Storage.put/1","type":"callback"},{"doc":"Return url with which one can access the file in the storage.","ref":"IVCU.Storage.html#c:url/1","title":"IVCU.Storage.url/1","type":"callback"},{"doc":"An error raised when a command in IVCU.Converter.CMD config has invalid format.","ref":"IVCU.Converter.CMD.InvalidFormatError.html","title":"IVCU.Converter.CMD.InvalidFormatError","type":"exception"},{"doc":"An error raised when your definition provides a version that was not specified in IVCU.Converter.CMD config.","ref":"IVCU.Converter.CMD.UnknownVersionError.html","title":"IVCU.Converter.CMD.UnknownVersionError","type":"exception"},{"doc":"","ref":"getting_started.html","title":"Getting Started","type":"extras"},{"doc":"The package can be installed by adding ivcu to your list of dependencies in mix.exs : def deps do [ { :ivcu , &quot;~&gt; 0.1.1&quot; } ] end","ref":"getting_started.html#install","title":"Getting Started - Install","type":"extras"},{"doc":"Storage is a module that implements IVCU.Storage behaviour. The easiest option is to use IVCU.Storage.Local . If you want to upload your files to S3, you may want to use ivcu_s3_storage . defmodule MyApp.LocalFileStorage do use IVCU.Storage.Local , otp_app : :my_app end","ref":"getting_started.html#define-a-storage","title":"Getting Started - Define a storage","type":"extras"},{"doc":"Converter is a module that implements IVCU.Converter behaviour. IVCU provides IVCU.Converter.CMD that can be used to define a converter that uses imagemagick 's convert binary. defmodule MyApp.ImageConverter do use IVCU.Converter.CMD , args : %{ thumb : [ &quot;convert&quot; , :input , &quot;-thumbnail&quot; , &quot;100x100^&quot; , &quot;-gravity&quot; , &quot;center&quot; , &quot;-extent&quot; , &quot;100x100&quot; , :output ] } end","ref":"getting_started.html#define-a-converter","title":"Getting Started - Define a converter","type":"extras"},{"doc":"To process a file in specific way you need to define a definition -- a module that implements IVCU.Definition behaviour. defmodule MyApp.Image do @behaviour IVCU.Definition def versions , do : [ :thumb , :original ] def storage , do : MyApp.LocalFileStorage def converter , do : MyApp.ImageConverter def validate ( %{ filename : filename } ) do if Path . extname ( filename ) in ~w(.png .jpg .jpeg) do :ok else { :error , :invalid_image_extension } end end def filename ( version , filename ) do extname = Path . extname ( filename ) base = filename |&gt; String . replace ( extname , &quot;&quot; ) &quot; \#{ base } _ \#{ version } \#{ extname } &quot; end end","ref":"getting_started.html#define-a-definition","title":"Getting Started - Define a definition","type":"extras"},{"doc":"def save_upload ( % Plug.Upload { path : path } ) do path |&gt; IVCU.File . from_path ( ) |&gt; IVCU . save ( MyApp.Image ) end","ref":"getting_started.html#save-a-new-file","title":"Getting Started - Save a new file","type":"extras"},{"doc":"def thumb_url ( filename ) do %{ thumb : url } = filename |&gt; IVCU.File . from_path ( ) |&gt; IVCU . urls ( ) url end","ref":"getting_started.html#get-files-urls","title":"Getting Started - Get files' URLs","type":"extras"},{"doc":"def delete_old_file ( filename ) do filename |&gt; IVCU.File . from_path ( ) |&gt; IVCU . delete ( ) end","ref":"getting_started.html#delete-all-versions-of-a-file","title":"Getting Started - Delete all versions of a file","type":"extras"},{"doc":"After you finished Getting Started guide, you may be interested how to use this library with ecto . The general approach is to link your files to some database entries.","ref":"using_with_ecto.html","title":"Using with ecto","type":"extras"},{"doc":"Suppose we have the following simple schema for users. defmodule MyApp.User do use Ecto.Schema alias Ecto.Changeset schema &quot;users&quot; do field :username , :string timestamps ( ) end def changeset ( user , attrs ) do user |&gt; Changeset . cast ( attrs , [ :username ] ) |&gt; Changeset . validate_required ( [ :username ] ) end end And this is the module responsible for busyness logic. defmodule MyApp.UserQueries do alias MyApp . { Repo , User } def create ( attrs ) do % User { } |&gt; User . changeset ( attrs ) |&gt; Repo . insert ( ) end end","ref":"using_with_ecto.html#defined-schema","title":"Using with ecto - Defined schema","type":"extras"},{"doc":"Now we want to be able to attach avatars. First we add :string field to the schema and modify MyApp.User.changeset/2 function. defmodule MyApp.User do use Ecto.Schema alias Ecto.Changeset schema &quot;users&quot; do field :username , :string field :avatar , :string timestamps ( ) end def changeset ( user , attrs ) do user |&gt; Changeset . cast ( attrs , [ :username , :avatar ] ) |&gt; Changeset . validate_required ( [ :username , :avatar ] ) end end","ref":"using_with_ecto.html#adding-avatars-to-the-schema","title":"Using with ecto - Adding avatars to the schema","type":"extras"},{"doc":"Then we add image processing logic to MyApp.UserQueries . defmodule MyApp.UserQueries do alias MyApp . { Repo , User } def create ( attrs ) do with { :ok , filename } &lt;- handle_image ( attrs ) do do_create ( %{ attrs | &quot;avatar&quot; =&gt; filename } ) end end # This function is responsible for actual image uploading. defp handle_image ( %{ &quot;avatar&quot; =&gt; % Plug.Upload { path : path } } ) do %{ filename : filename } = file = IVCU.File . from_path ( path ) with { :ok , _ } &lt;- IVCU . save ( file , MyApp.Image ) do { :ok , filename } end end defp handle_image ( _ ) do { :error , :avatar_is_missing } end # Here we moved actual call database interaction into a separate # function. defp do_create ( attrs ) do % User { } |&gt; User . changeset ( attrs ) |&gt; Repo . insert ( ) end end Warning Of cause you can implement more sophisticated validations on the input. The code above provided for demonstration purposes only.","ref":"using_with_ecto.html#handling-avatar-uploading","title":"Using with ecto - Handling avatar uploading","type":"extras"},{"doc":"After finishing Using with ecto guide you may be interested in interactions with Phoenix .","ref":"using_with_phoenix.html","title":"Using with Phoenix","type":"extras"},{"doc":"We can guess that the action above was triggered somewhere in a controller. Suppose we have standard JSON API with Phoenix. For the client to be able to see links to the avatars we need to add them to an appropriate view. defmodule MyAppWeb.UserView do alias MyApp.Image def render ( &quot;user.json&quot; , %{ user : user } ) do %{ original : original_path , thumb : thumb_path } = user . avatar |&gt; IVCU.File . from_path ( ) |&gt; IVCU . urls ( Image ) base_url = Application . get_env ( :my_app , :base_url ) %{ username : user . username , avatar : &quot; \#{ base_url } \#{ original_path } &quot; , avatar_thumb : &quot; \#{ base_url } \#{ thumb_path } &quot; , } end end Note For S3 storage you don't need to build full url as its storage returns full urls on its own.","ref":"using_with_phoenix.html#returning-links-to-the-user","title":"Using with Phoenix - Returning links to the user","type":"extras"},{"doc":"If we are to serve locally saved files, we need to configure Plug.Static plug. defmodule MyAppWeb.Endpoind do # ... plug Plug.Static , at : &quot;/uploads&quot; , from : &quot;./uploads&quot; # ... end Note For S3 storage you don't need to serve static files as links point to the bucket, not to your application.","ref":"using_with_phoenix.html#configuring-static-serving","title":"Using with Phoenix - Configuring static serving","type":"extras"}]